#pragma once

#include "v3.h"
#include "ppc.h"

class TMesh {
  V3 *verts, *projVerts;
  V3 *colors, *normals;
  int vertsN;
  unsigned int *connectivity;
  int trianglesN;
  void Project(PPC *ppc);
public:
  TMesh();
  void Initialize();
  void SetAABB(AABB aabb);
  void Allocate();
  void RenderPoints(V3 color, PPC *ppc, 
    FrameBuffer *fb);
  void RenderWireFrame(V3 color, PPC *ppc, 
    FrameBuffer *fb);
  void Load(char *fname);
};